美文网首页
[Leetcode] 1. Two Sum 两数之和

[Leetcode] 1. Two Sum 两数之和

作者: lijia069 | 来源:发表于2017-12-15 16:25 被阅读0次

    Related Topics:[Array][Hash Table]
    Similar Questions
    [3Sum][4Sum][Two Sum II - Input array is sorted][Two Sum III - Data structure design][Subarray Sum Equals K][Two Sum IV - Input is a BST]

    题目:Given an array of integers, return indices of the two numbers such that they add up to a specific target.

    You may assume that each input would have exactly one solution.

    Example:

    Given nums = [2, 7, 11, 15], target = 9,

    Because nums[0] + nums[1] = 2 + 7 = 9,
    return [0, 1].

    思路1

    暴力搜索,两层循环遍历数组进行查找。该算法时间复杂度是O(n^2)。

    java解法:

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            for(int i=0;i<nums.length-1;i++) {
                for(int j=i+1;j<nums.length;j++) {
                    if(nums[i]+nums[j]==target) {
                        return new int[]{i,j};
                    }
                }
            }
            throw new IllegalArgumentException("No two sum solution");
        }
    }
    

    思路二

    本题目标是对数组的元素值进行判断,返回对应值的索引号,因此可以建立值-索引映射,用Map结构对数据进行查找。使用map的时间复杂度为O(n)。

    方法一

    使用两层迭代,第一层将整个数组装入Map结构中,第二层在Map结构中查找符合要求的key即元素值,并返回对应的value即元素索引。

    java解法1

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            Map<Integer,Integer> map=new HashMap<>();
            for(int i=0;i<nums.length;i++) {
                map.put(nums[i],i);
            }
            for(int i=0;i<nums.length;i++) {
                int complement=target-nums[i];
                //此处要注意两个值应代表不同元素
                if(map.containsKey(complement)&&i!=map.get(complement)) {
                    return new int[]{i,map.get(complement)};
                }
            }
            throw new IllegalArgumentException("No two sum solution");
        }
    }
    

    方法二

    可以将方法二中的两次循环合为一个循环,一边将元素及索引存入map结构,一遍查看map中是否已有与该元素相加为target的值。

    java解法2

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            Map<Integer,Integer> map=new HashMap<>();
            for(int i=0;i<nums.length;i++) {
                int complement=target-nums[i];
                if(map.containsKey(complement)) {
                    return new int[]{map.get(complement),i};
                }
                map.put(nums[i],i);
            }        
            throw new IllegalArgumentException("No two sum solution");
        }
    }
    

    相关文章

      网友评论

          本文标题:[Leetcode] 1. Two Sum 两数之和

          本文链接:https://www.haomeiwen.com/subject/faldwxtx.html